## Add items to shipping method

### cURL

```bash
curl --request POST \
  --url https://api.fabric.inc/v3/shipping-methods/{shippingMethodId}/actions/add-items \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-fabric-channel-id: <x-fabric-channel-id>' \
  --header 'x-fabric-tenant-id: <x-fabric-tenant-id>' \
  --data '{
  "itemIds": [\
    111223,\
    224444\
  ]
}'
```

### Python

```python
import requests

url = "https://api.fabric.inc/v3/shipping-methods/{shippingMethodId}/actions/add-items"

payload = { "itemIds": [111223, 224444] }
headers = {
    "x-fabric-tenant-id": "<x-fabric-tenant-id>",
    "x-fabric-channel-id": "<x-fabric-channel-id>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

### JavaScript

```javascript
const options = {
  method: 'POST',
  headers: {
    'x-fabric-tenant-id': '<x-fabric-tenant-id>',
    'x-fabric-channel-id': '<x-fabric-channel-id>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({itemIds: [111223, 224444]})
};

fetch('https://api.fabric.inc/v3/shipping-methods/{shippingMethodId}/actions/add-items', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### PHP

```php
$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.fabric.inc/v3/shipping-methods/{shippingMethodId}/actions/add-items",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'itemIds' => [
        111223,
        224444
    ]
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json",
    "x-fabric-channel-id: <x-fabric-channel-id>",
    "x-fabric-tenant-id: <x-fabric-tenant-id>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
```

### Go

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

url := "https://api.fabric.inc/v3/shipping-methods/{shippingMethodId}/actions/add-items"

payload := strings.NewReader("{\n  \"itemIds\": [\n    111223,\n    224444\n  ]\n}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("x-fabric-tenant-id", "<x-fabric-tenant-id>")
	req.Header.Add("x-fabric-channel-id", "<x-fabric-channel-id>")
	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}
```

### Response Codes

- **201**: Created - Details to add items to or delete items from shipping method.
- **400**: Bad Request - Invalid request.
- **401**: Unauthorized - Unauthorized request.
- **404**: Not Found - Shipping method not found.
- **500**: Internal Server Error.

### Example Response

```json
{
  "shippingMethodItems": [
    {
      "itemId": 1234,
      "shippingMethodId": "5349b4ddd2781d08c09890f4",
      "isDeleted": false
    }
  ]
}
```

```json
{
  "errors": [
    {
      "message": "Invalid request",
      "type": "CLIENT_ERROR"
    }
  ],
  "message": "Bad request",
  "type": "CLIENT_ERROR"
}
```

```json
{
  "message": "Unauthorized request",
  "type": "CLIENT_ERROR"
}
```

### Required Headers

- **Authorization**: Bearer authentication header of the form `Bearer <token>`.
- **x-fabric-tenant-id**: A header used by fabric to identify the tenant making the request.
- **x-fabric-channel-id**: Identifies the sales channel; defaults to *12*.
